//------------------------------------------------------------------------------
//
// Header.java   CBP 07-01-20
//
// Header file for 2020 Schools. Includes Turtles, but not Critters
//
//
//------------------------------------------------------------------------------
import java.util.*;
import java.awt.*;
import java.lang.*;

public class Compiland extends Helper {

int INTERMEDIATE = 1;
int ADVANCED = 2;

// Turtle stuff ---------------------------------------
Turtle turtle1;
Turtle turtle2;

// New WeeBees : Must go into hard code ---------------
WeeBee zon;
WeeBee mop;
WeeBee saff;
WeeBee tod;

// Fishtank stuff -------------------------------------

// Now declare the scenery for SpaceChasers ------------

// ----------------------------------------------------------------

public void init() {
//  canvas.animationTime=2.0;
//  canvas.gui.selectedSourcePanel.setFontSize(14);
//  canvas.gui.selectedSourcePanel.setFont("Calibri",Font.PLAIN,18);
//  canvas.gui.selectedSourcePanel.setFont("Ariel",Font.BOLD,16);
  
  //canvas.userLevel = ADVANCED;
  canvas.userLevel = INTERMEDIATE;
  
  // Turtle Graphics ----------------------------------------------
  turtle1 = new Turtle(canvas,"Turtlered","Turt1");
  turtle2 = new Turtle(canvas,"Turtlegreen","Turt2");  

  // New Scenery --------------------------------------------------  

	
  // Here comes the new WeeBees --------- October 2019 ------------ 
  
  zon = new WeeBee(canvas,"Zon");
  mop = new WeeBee(canvas,"Mop");  
  saff = new WeeBee(canvas,"Saff");    
  tod = new WeeBee(canvas,"Tod"); 
  
  // And now the FishTank --------------- November 2019 -----------
  
}  
// =======================================
//
// WBCode  robot_1.cde
// CBP 18-10-19
//
// =======================================

// Declare the states we shall use as CONSTANTS
static final String STATE_1 = "STATE_1";
static final String STATE_2 = "STATE_2";

// Declare the variables we shall use ----------
// Positions, both x-y and angle ...............
float x;
float y;
float theta; // This is the angle (in degrees)
// Now the velocities ..........................
float vX;
float vY;
float omega; // This is angular velocity

// Stuff related to time .......................
float dT;
int runTime;

// Finally the state ...........................
String state;

public void once() {

  // Set initial values of the variables we use .
  x = 40;
  y = 30;
  theta = 0;
  dT = 0.01F;
  runTime = 5;

  showGrid();
  setScene("TurtleBackground1");

  // The turtle1 will move, pip will run the engine
  add(turtle1,x,10);
  add(pip,5,5);
  pip.rest(runTime);  

  // Must place the FSM into its initial state.
  state = STATE_1;

}

public void loop() {


  switch(state) { // Start of the FSM -------------

    case STATE_1:
      vX = 50.0F;
      vY = 0;
      omega = 0;
      if(x > 70)
        state = STATE_2;
    break;

    case STATE_2:
	  vX = 0;
      vY = 0;
      omega = 0; 
    break;

  } // End of the FSM -----------------------------

  // Execute the Dynamics--------------------------
  // First the translation ........................
  x = x + vX*dT;
  y = y + vY*dT;
  turtle1.moveTo(x,y);

  // Then the rotation ............................
  theta = theta + omega*dT;
  turtle1.turn(theta);

  // Now output stuff to the console --------------
  consoleWrite("STATE = "+ state + "\n");

}


public void consoleWrite(String str) {
  canvas.gui.msgOutput.setText(str);
}
  
}
